/*
** dyn.c for elfsh
** 
** Started on  Fri Nov  2 15:17:36 2001 mayhem
** Last update Thu Feb 28 20:35:51 2002 mayhem
*/
#include "elfsh.h"






/* Display the .dynamic section entries */
int		display_dyn(Elfsh32_Obj *file, argv_t *args)
{
  Elf32_Dyn	*actual;
  int		num;
  int		index;
  int		typenum;
  char		*type;
  regex_t	*tmp;
  char		buff[256];
  
  if ((actual = elfsh_get_dynamic(file, &num)) == NULL)
    RET(-1);
  
  tmp = (REGX_IS_USED(args->dyn_use_regx) ? &args->dyn_regx : 
	 REGX_IS_USED(args->gl_use_regx)  ? &args->gl_regx : NULL);
  
  puts("\n[SHT_DYNAMIC]");
  
  for (index = 0; index < num && actual[index].d_tag != DT_NULL; index++)
    {
      
      typenum = elfsh_get_dynentry_type(actual + index);

      type = (typenum >= DYNAMIC_MAX ? "*Unknown*" : elfsh_dynentry_type[typenum]);
      
      snprintf(buff, sizeof(buff), "\t%-40s : \t\t\t %20s", type, elfsh_get_dynentry_info(file, actual + index));
      if (!tmp || (tmp && !regexec(tmp, buff, 0, 0, 0)))
	puts(buff);

    }
  
  puts("");
  return (0);
}







