/*
** pht.c for elfsh
** 
** Started on  Fri Nov  2 15:18:35 2001 mayhem
** Last update Thu Feb 28 17:58:50 2002 mayhem
*/
#include "elfsh.h"









/* Display the program header table (pht) */
int		display_pht(Elfsh32_Obj *file, argv_t *av)
{
  Elf32_Phdr	*phdr;
  int		num;
  int		index;
  char		*type;
  u_int		typenum;

  if ((phdr = elfsh_get_pht(file, &num)) == 0)
    RET(-1);
  
  puts("\n\n[PROGRAM HEADER TABLE]");

  for (index = 0; index < num; index++)
    {
      
      typenum = elfsh_get_segment_type(&phdr[index]);
      type = (typenum >= SEGTYPE_MAX ? "Unknown" : elfsh_seg_type[typenum]);
      
      printf("%-10p %c%c%c msize: %7u bytes foffset: %8p fsize: %7u bytes (%04u bytes aligned) [%s] \n",
	     (void *) phdr[index].p_vaddr,
	     (elfsh_segment_is_readable(&phdr[index])   ? 'r' : '-'),
	     (elfsh_segment_is_writable(&phdr[index])   ? 'w' : '-'),
	     (elfsh_segment_is_executable(&phdr[index]) ? 'x' : '-'),
	     phdr[index].p_memsz,
	     (void *) phdr[index].p_offset,
	     phdr[index].p_filesz,
	     phdr[index].p_align,
	     type);
      
    }


  puts("");
  return (0);
}
