/*
** plt.c for libelfsh
** 
** Started on  Tue Jul 24 06:40:07 2001 mayhem
** Last update Wed Feb 27 19:40:58 2002 mayhem
*/
#include "libelfsh.h"




/* Return 1 if the section is the plt or 0 if its not */
int		elfsh_is_plt(Elfsh32_Obj *file, Elf32_Shdr *sct)
{
  if (!strcmp(elfsh_get_section_name(file, sct), ELFSH_SECTION_NAME_PLT))
    return (1);
  return (0);
}





/* Load the procedure linkage table (.plt) section */
Elfsh32_Sect	*elfsh_get_plt(Elfsh32_Obj *file, int *num)
{
  Elfsh32_Sect	*s;
  int		index;

  if (!file->plt)
    {
      s = elfsh_get_section_by_name(file, ELFSH_SECTION_NAME_PLT, &index, NULL, NULL);
      if (!s)
	return (NULL);
      file->plt = s;
      s->nbr = s->shdr->sh_size / ELFSH_PLT_ENTRY_SIZE; 
    }

  if (num)
    *num = s->nbr;

  return (file->plt);
}





/* Return 1 if the symbol points in the PLT */
int			elfsh_is_pltentry(Elfsh32_Obj *file, Elf32_Sym *sym)
{
  Elfsh32_Sect		*s;

  if ((s = elfsh_get_plt(file, NULL)) == NULL)
    return (-1);
  
  if (INTERVAL(s->shdr->sh_addr, sym->st_value, s->shdr->sh_addr + s->shdr->sh_size));
    return (1);
  
  return (0);
}
































