/*
** raw.c for libelfsh
** 
** Started on  Wed Feb 27 19:41:45 2002 mayhem
** Last update Sat Mar  2 17:33:46 2002 mayhem
*/
#include "libelfsh.h"



/* Perform a raw write on the object cache data */
int	elfsh_raw_write(Elfsh32_Obj *file, u_int dst, void *src, int len)
{
  return (-1);
}




/* Perform a raw read on the object cache data */
int	elfsh_raw_read(Elfsh32_Obj *file, u_int dst, void *buff, int len)
{
  Elfsh32_Sect	*sect;
  void		*src;
  int		sect_off;

  sect = elfsh_get_parent_section(file, dst, NULL);
  if (sect == NULL)
    ELFSH_SETERROR("libelfsh: Invalid virtual address .", -1);

  sect_off = dst - sect->shdr->sh_addr;

  if (sect_off + len > sect->shdr->sh_size)
    len -= (sect_off + len - sect->shdr->sh_size);

  src = elfsh_get_anonymous_section(file, sect);
  if (!src)
    return (0);

  memcpy(buff, src + sect_off, len);
  return (len);

}
