/*
** sht.c for libelfsh
** 
** Started on  Mon Feb 26 04:16:18 2001 mayhem
** Last update Tue Feb 26 21:06:51 2002 mayhem
*/
#include "libelfsh.h"




/* Return a ptr on the section header table */
void		*elfsh_get_sht(Elfsh32_Obj *file, int *num)
{
  Elfsh32_Sect	*s;

  if (!file->sht)
    {

      if (elfsh_load_sht(file) == -1)
	return (NULL);
      
      /* now load the section string table */
      s = elfsh_get_section_by_index(file, file->hdr->e_shstrndx, NULL, NULL);
      if (!s)
	return (NULL);

      file->sh_strtab = s;
      s->data = elfsh_load_section(file, s->shdr);
      if (!s->data)
	ELFSH_SETERROR("elfsh_get_sht: Cant read sht in the ELF file .", NULL);

      s->nbr = s->shdr->sh_size;
    }

  if (num)
    *num = file->hdr->e_shnum;

  return (file->sht);

}





/* Return an array of section header */
int		elfsh_load_sht(Elfsh32_Obj *file)
{
  Elfsh32_Sect	*new;
  int		size;
  int		index;

  if (!file->hdr && !elfsh_get_hdr(file))
    return (-1);

  if (file->sht)
    return (0);
  
  size = file->hdr->e_shnum * file->hdr->e_shentsize;
  
  XALLOC(file->sht, size, -1);
  XSEEK(file->fd, file->hdr->e_shoff, SEEK_SET, -1);
  XREAD(file->fd, file->sht, size, -1);

  /* Allocate a Elfsh32_Sect per section and put it in the file->sections double linked list */
  for (index = 0; index < file->hdr->e_shnum; index++)
    {
      XALLOC(new, sizeof(Elfsh32_Sect), -1);
      new->shdr = file->sht + index;
      new->parent = file;
      new->index = index;
      new->phdr = elfsh_get_parent_pheader(new);
      elfsh_add_section(file, new, ELFSH_SECTION_LAST);
    }

  return (0);
}


































